#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "my_uart.h"
#include "app_usbd_cdc_acm.h"
#include "nrf_delay.h"

/**
 * @brief CDC_ACM class instance
 * */
APP_USBD_CDC_ACM_GLOBAL_DEF(n_app_cdc_acm,
                            cdc_acm_user_ev_handler,
                            CDC_ACM_COMM_INTERFACE,
                            CDC_ACM_DATA_INTERFACE,
                            CDC_ACM_COMM_EPIN,
                            CDC_ACM_DATA_EPIN,
                            CDC_ACM_DATA_EPOUT,
                            APP_USBD_CDC_COMM_PROTOCOL_AT_V250);

const app_usbd_cdc_acm_t *usb_uart = &n_app_cdc_acm;

void usb_printf_len(char *string, int len);

void usb_printf(char *string)
{
  app_usbd_cdc_acm_write(usb_uart,
                         string,
                         strlen(string)); // ⴮ڴӡflashжȡ
  nrf_delay_us(100);                      // ٽprintf֮ҪһСʱ
}

void usb_printf_len(char *string, int len)
{
  app_usbd_cdc_acm_write(usb_uart,
                         string,
                         len); // ⴮ڴӡflashжȡ
  nrf_delay_us(100);           // ٽprintf֮ҪһСʱ
}

// µĺʵprintfĹ
void usb_printf_variadic(const char *format, ...)
{
  char buffer[256]; // һַ洢ɵĸʽַ
  va_list args;     // һva_list͵ıɱ

  va_start(args, format);                          // ʼargsformatһ̶
  vsnprintf(buffer, sizeof(buffer), format, args); // ʹvsnprintfʽַ
  va_end(args);                                    // args

  usb_printf(buffer); // usb_printf͸ʽַ
}
